﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=5.2
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Public manager As BleManager2
	Public currentStateText As String = "UNKNOWN"
	Public currentState As Int
	Public connected As Boolean = False
	Public ConnectedName As String
	Public ConnectedServices As List
	Public rp As RuntimePermissions
	Public notification_characteristics As String
End Sub

Sub Service_Create
	manager.Initialize("manager")
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Public Sub ReadData
	For Each s As String In ConnectedServices
		manager.ReadData(s)
	Next
End Sub

Public Sub Disconnect
	manager.Disconnect
	Manager_Disconnected
End Sub

Sub Manager_StateChanged (State As Int)
	Select State
		Case manager.STATE_POWERED_OFF
			currentStateText = "POWERED OFF"
		Case manager.STATE_POWERED_ON
			currentStateText = "POWERED ON"
		Case manager.STATE_UNSUPPORTED
			currentStateText = "UNSUPPORTED"
	End Select
	currentState = State
	Log("Manager_StateChanged "&currentStateText)
	CallSub(Main, "StateChanged")
End Sub

Sub Manager_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)
	Log("Found: " & Name & ", " & Id & ", RSSI = " & RSSI & ", " & AdvertisingData) 'ignore
	'If Name <> "JX-05S" Then
	'	Return
	'End If
	CallSub3(Main, "DeviceAvailable", Name, Id)
End Sub

Sub ConnectDevice(Name As String, Id As String)
	ConnectedName = Name
	manager.StopScan
	manager.Connect2(Id, False) 'disabling auto connect can make the connection quicker
End Sub

Public Sub StartScan
	If manager.State <> manager.STATE_POWERED_ON Then
		Log("Not powered on.")
	Else If rp.Check(rp.PERMISSION_ACCESS_COARSE_LOCATION) = False Then
		Log("No location permission.")
	Else
		manager.Scan2(Null, False)
	End If
End Sub

Public Sub StopScan
	manager.StopScan
End Sub


Sub Manager_DataAvailable (ServiceId As String, Characteristics As Map)
'	Dim received = ""
'	
'	Try:
'		received = manager.ReadData2(ServiceId, Characteristics)
'	Catch:
'		Log(LastException)
'	End Try
'	
'	Log(received)


	'Dim BC As ByteConverter
	'Log(BC.StringFromBytes(Characteristics,"utf-8"))


	
	CallSub3(Main, "DataAvailable", ServiceId, Characteristics)
	

	
End Sub


Sub Manager_Disconnected
	Log("Disconnected")
	connected = False
	CallSub(Main, "StateChanged")
End Sub

Sub Manager_Connected (services As List)
	
	Dim ServiceId As String
	
	Log("Connected")
	connected = True
	ConnectedServices = services
	Log(ConnectedServices)
	CallSub(Main, "StateChanged")

	'For i=0 To services.Size-1
		
	'manager.ReadData(services.Get(services.Size-1))
	'Next

End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

Sub Float2Bytes(float_nr As Double, val_type As Int) As Byte()
	Dim tint As Int', tint_orig As Int
	Dim b(6) As Byte
	
	tint = float_nr * 1000000
	'tint_orig = tint
	b(0) = 126 '"~"
	b(1) = val_type
	b(2) = Bit.And(tint,255)
	tint = Bit.UnsignedShiftRight(tint, 8)
	b(3) = Bit.And(tint,255)
	tint = Bit.UnsignedShiftRight(tint, 8)
	b(4) = Bit.And(tint,255)
	tint = Bit.UnsignedShiftRight(tint, 8)
	b(5) = Bit.And(tint,255)
	Return(b)
End Sub

Sub Location2Bytes(LocationLoc As LocationType, val_type As Int) As Byte()
	Dim lat_int As Int, lng_int As Int
	Dim b(10) As Byte
	
	lat_int = LocationLoc.lat * 1000000
	lng_int = LocationLoc.lng * 1000000
	'tint_orig = tint
	b(0) = 126 '"~"
	b(1) = val_type
	b(2) = Bit.And(lat_int,255)
	lat_int = Bit.UnsignedShiftRight(lat_int, 8)
	b(3) = Bit.And(lat_int,255)
	lat_int = Bit.UnsignedShiftRight(lat_int, 8)
	b(4) = Bit.And(lat_int,255)
	lat_int = Bit.UnsignedShiftRight(lat_int, 8)
	b(5) = Bit.And(lat_int,255)
	
	b(6) = Bit.And(lng_int,255)
	lng_int = Bit.UnsignedShiftRight(lng_int, 8)
	b(7) = Bit.And(lng_int,255)
	lng_int = Bit.UnsignedShiftRight(lng_int, 8)
	b(8) = Bit.And(lng_int,255)
	lng_int = Bit.UnsignedShiftRight(lng_int, 8)
	b(9) = Bit.And(lng_int,255)
	Return(b)
End Sub


public Sub WriteData(Characteristic As Object, Value As String)
	If Not(connected) Then Return
	Dim myCharacteristic As Characteristic = Characteristic
	Log("Write: " & Value & " to " & myCharacteristic.CharacteristicId)
	Try:
		'manager.WriteData(myCharacteristic.ServiceId, myCharacteristic.CharacteristicId, Value.GetBytes("UTF8"))
		'this below will make no changes to characters!!!
		manager.WriteData(myCharacteristic.ServiceId, myCharacteristic.CharacteristicId, Value.GetBytes("latin1"))
	Catch:
		Log("Error")
	End Try
End Sub

public Sub WriteLocation(Characteristic As Object, LocationLoc As LocationType)
	If Not(connected) Then Return
	Dim myCharacteristic As Characteristic = Characteristic
	Dim byt(10) As Byte
	Dim data_type As Int
	
	data_type = myCharacteristic.Value
	Log("Write: " & LocationLoc.lat & " " & LocationLoc.lng& " to " & myCharacteristic.CharacteristicId)
	Try:
		'manager.WriteData(myCharacteristic.ServiceId, myCharacteristic.CharacteristicId, Value.GetBytes("UTF8"))
		'this below will make no changes to characters!!!
		
		If myCharacteristic.CharacteristicId <> "" Then
			byt= Location2Bytes(LocationLoc, data_type) 'Latitude
			For j = 0 To 9
				Log(byt(j))
			Next
			Log(myCharacteristic.ServiceId)
			manager.WriteData(myCharacteristic.ServiceId, myCharacteristic.CharacteristicId, byt)
		End If
	Catch:
		Log(LastException)
		Log("Error in BLE messages flow... Reconnect...")
		CallSub(Main, "ResetBLEConnection")
	End Try
End Sub


public Sub WriteFloat(Characteristic As Object, Value As Double)
	If Not(connected) Then Return
	Dim myCharacteristic As Characteristic = Characteristic
	Dim byt(6) As Byte
	Dim data_type As Int
	
	data_type = myCharacteristic.Value
	Log("Write: " & Value & " to " & myCharacteristic.CharacteristicId)
	Try:
		'manager.WriteData(myCharacteristic.ServiceId, myCharacteristic.CharacteristicId, Value.GetBytes("UTF8"))
		'this below will make no changes to characters!!!
		byt= Float2Bytes(Value,data_type) 'Latitude
		Log(byt(0))
		Log(byt(1))
		Log(byt(2))
		Log(byt(3))
		Log(byt(4))
		Log(byt(5))
		manager.WriteData(myCharacteristic.ServiceId, myCharacteristic.CharacteristicId, byt)
	Catch:
		Log("Error")
	End Try
End Sub


